<script>
  import { createEventDispatcher } from 'svelte';

  // stores
  import meetups from '../../meetups-store';

  // UI
  import TextInput from '../UI/TextInput.svelte';
  import Button from '../UI/Button.svelte';
  import Modal from '../UI/Modal.svelte';

  // validators
  import { isEmpty, isValidEmail } from '../../helpers/validation';

  let title = '';
  let subtitle = '';
  let description = '';
  let imageUrl = '';
  let address = '';
  let email = '';

  export let id = null;

  if (id) {
    const unsubscribe = meetups.subscribe(items => {
      const selectedMeetup = items.find(i => i.id === id);
      title = selectedMeetup.title;
      subtitle = selectedMeetup.subtitle;
      description = selectedMeetup.description;
      imageUrl = selectedMeetup.imageUrl;
      address = selectedMeetup.address;
      email = selectedMeetup.contactEmail;
    })

    unsubscribe();
  }

  const dispatch = createEventDispatcher();

  $: titleValid = !isEmpty(title);
  $: subtitleValid = !isEmpty(subtitle);
  $: descriptionValid = !isEmpty(description);
  $: imageUrlValid = !isEmpty(imageUrl);
  $: addressValid = !isEmpty(address);
  $: emailValid = !isEmpty(address) && isValidEmail(email);
  $: formValid = titleValid && subtitleValid && descriptionValid &&
                  imageUrlValid && addressValid && emailValid

  function submitForm() {
    const meetupData = {
      contactEmail: email,
      title,
      subtitle,
      description,
      imageUrl,
      address
    };

    if (id) {
      fetch(`https://meetus-svelte.firebaseio.com/meetups/${id}.json`, {
        method: 'PATCH',
        body: JSON.stringify(meetupData),
        headers: { 'Content-Type': 'application/json' }
      })
        .then( res => {
          if (!res.ok) throw new Error('An error occured, please try again');
          meetups.updateMeetup(id, meetupData);
        })
        .catch((err) => console.log(err));
    } else {
      fetch('https://meetus-svelte.firebaseio.com/meetups.json', {
        method: 'POST',
        body: JSON.stringify({...meetupData, isFavorite: false}),
        headers: { 'Content-Type': 'application/json' }
      })
        .then( res => {
          if (!res.ok) throw new Error('An error occured, please try again');
          return res.json()
        })
        .then(data => {
          meetups.addMeetup({...meetupData, isFavorite: false, id: data.name});
        })
        .catch((err) => console.log(err));
    }
    
    dispatch('save');
  }

  function deleteMeetup() {
    fetch(`https://meetus-svelte.firebaseio.com/meetups/${id}.json`, {
      method: 'DELETE'
    })
      .then( res => {
        if (!res.ok) throw new Error('An error occured, please try again');
        meetups.deleteMeetup(id);
        dispatch('save');
      })
      .catch((err) => console.log(err));
  }

  function cancel() {
    dispatch('cancel');
  }
</script>

<style>
  form {
    width: 100%;
  }
</style>

<Modal title="Edit Meetup Data" on:cancel>
  <form on:submit|preventDefault="{submitForm}">
    <TextInput
      label="Title"
      id="title"
      valid={titleValid}
      validityMessage="Please enter valid title"
      value={title}
      on:input={(event) => title = event.target.value}/>
    <TextInput
      label="Subtitle"
      id="subtitle"
      valid={subtitleValid}
      validityMessage="Please enter valid subtitle"
      value={subtitle}
      on:input={(event) => subtitle = event.target.value}/>
    <TextInput
      label="Address"
      id="address"
      valid={addressValid}
      validityMessage="Please enter valid address"
      value={address}
      on:input={(event) => address = event.target.value}/>
    <TextInput
      label="Image Url"
      id="imageUrl"
      valid={imageUrlValid}
      validityMessage="Please enter valid image url"
      value={imageUrl}
      on:input={(event) => imageUrl = event.target.value}/>
    <TextInput
      label="Email"
      id="email"
      valid={emailValid}
      validityMessage="Please enter valid email"
      value={email}
      on:input={(event) => email = event.target.value}/>
    <TextInput
      label="Description"
      controlType="textarea"
      rows="3"
      id="imageUrl"
      valid={descriptionValid}
      validityMessage="Please enter valid description"
      bind:value={description} />
  </form>
  <div slot="footer">
    <Button mode="outline" on:click={cancel}>Cancel</Button>
    <Button on:click={submitForm} disabled={!formValid}>Save</Button>
    {#if id}
      <Button on:click={deleteMeetup}>Delete</Button>
    {/if}
  </div>
</Modal>
